Bug 416201 - iSCSI initiator triggers lockdep and hangs upon logout from target
iSCSI initiator triggers lockdep and hangs upon logout from target
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
All Linux
low Severity low
: ---
: ---
Assigned To: Mike Christie
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2007-12-07 17:33 EST by Daniel Berrange
Modified: 2009-07-14 12:00 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2009-07-14 12:00:33 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Lockdep trace from kernel (108.61 KB, text/plain)
2007-12-07 17:34 EST, Daniel Berrange
no flags Details
Dump from sysrq+t showing 'iscsid' waiting on a mutex lock (370.60 KB, text/plain)
2007-12-07 17:34 EST, Daniel Berrange
no flags Details

  None (edit)
Description Daniel Berrange 2007-12-07 17:33:34 EST
Description of problem:
Attempting to use the iscsi-initiator-utils eventually results in the 'iscsid'
getting into an uninterruptable sleep. sysrq+t  shows that its stuck waiting on
a mutex lock. /var/log/messages also has giant lockdep reports about the iscsi code

Version-Release number of selected component (if applicable):

How reproducible:
Frequent (nearly always)

Steps to Reproduce:
1. Install  'iscsi-target-utils' on a server and export a target with a few LUNs
2. On a different machine login to the target, eg

iscsiadm -m node -p,1 --target
pumpkin.virt.boston.redhat.com:storage.virt --login

3. Now logout of the target

iscsiadm -m node -p,1 --target
pumpkin.virt.boston.redhat.com:storage.virt --logout

Repeat steps 2 & 3 until one of the commands hangs - usually the --logout
command hangs after just 2 iterations

The logout appears to have been successful - the client is removed from the
active initiators list on the server, and the local /dev/sd* devices have gone
away - but the client is hard locked and no further iscsiadm commands work
Actual results:
iscsiadm logout hangs

Expected results:
iscsiadm doesn't hang

Additional info:
Also reproduced on 2.6.23 and 2.6.22 kernels from F7 and F8
Comment 1 Daniel Berrange 2007-12-07 17:34:34 EST
Created attachment 281721 [details]
Lockdep trace from kernel
Comment 2 Daniel Berrange 2007-12-07 17:34:58 EST
Created attachment 281731 [details]
Dump from sysrq+t  showing 'iscsid' waiting on a mutex lock
Comment 3 Mike Christie 2008-01-03 14:45:41 EST
This should be fixed in 2.6.25 when it comes out. The patch to fix this is in
the scsi maintainer's tree waiting for the next merge window:

Comment 4 Daniel Berrange 2008-01-03 14:54:27 EST
If at all possible, can this patch be applied to the current Fedora 8 2.6.23
kernels.... I'm working on some projects which use iSCSI and this is a
showstopper bug for all development on Fedora 8 currently, and it'll be quite a
while before 2.6.25 makes it into Fedora.
Comment 5 Mike Christie 2008-01-03 15:02:43 EST
(In reply to comment #4)
> If at all possible, can this patch be applied to the current Fedora 8 2.6.23
> kernels.... 

Just the single patch cannot be ported. I can make up a port of all the patches
that are in the scsi maintainer's tree.

I think we need to ask the FC kernel maintainers what they want me to patch
against and if they will take it. Since it is going upstream in 2.6.25 I am
thinking they would be ok with it. Do we need to ask Dave Jones or did someone
else take over the FC kernel stuff?
Comment 6 Chris Lalancette 2008-01-08 15:03:51 EST
Dave Jones is usually the guy, but he hurt himself recently so is taking a few
weeks off.  The best bet is to start with fedora-kernel-list@redhat.com; the
relevant people there should be able to offer some guidance.

Chris Lalancette
Comment 7 Bug Zapper 2008-05-14 00:07:14 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
Comment 8 Bug Zapper 2009-06-09 19:15:45 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
Comment 9 Bug Zapper 2009-07-14 12:00:33 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.